## Script (Python) "getUploadsInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=student=None
##title=
##
# $Id:getUploadsInfo.py 486 2006-09-06 10:09:39Z joachim $
"""
return Info about the Uploads
"""
import DateTime
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
request = context.REQUEST

wf = context.portal_workflow
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()

path_info = request.get('PATH_INFO').split('/')

info = {}
info['action'] = "%s" % context.absolute_url()
info['choosen_ids'] = request.get('ids',[])
info['doc'] = context.getContent()

items = []
edit = request.form.has_key('edit')
ids = request.get('ids',[])
#set_trace()
if edit and ids:
    for id in ids:
        doc = getattr(context, "%s.csv" % id).getContent()
        doc.edit(mapping = request.form[id])
        msg, invalid_keys = doc['checkKeys']()
        new_keys = []
        for key in invalid_keys:
            id_key = "%s|%s" % (id,key)
            if request.form.has_key(id_key):
                new_keys += (key,request.form.get(id_key)['valid_key']),
        if new_keys:
            doc.editHeadline(new_keys)
        request.RESPONSE.redirect(context.absolute_url())    
        
for id,upload in context.objectItems():
    row = {}
    doc = upload.getContent()
    row['valid_keys'] = doc['getKeys']()
    row['id'] = id.replace('.csv','')
    row['title'] = doc.filename
    row['url'] = upload.absolute_url()
    row['msg'], row['invalid_keys'] = doc['checkKeys']()
    row['filename'] = doc.filename 
    row['import_layout'] = doc.import_layout
    row['upload_date'] =  doc.upload_date.strftime("%d/%m/%y %H:%M:%S")
    row['uploaded_by'] = doc.uploaded_by
    items.append(row)
items.sort()
info['items'] = items

validate = "upload" in request.keys()
mode = "edit"
res,psm,ds = context.portal_layouts.renderLayout(layout_id = 'upload',
                             schema_id = 'upload',
                             layout_mode = mode,
                             context=context,
                             mapping=validate and request,
                             ob= {},
                             commit = True,
                            )
if psm == 'invalid':
    return context.uploads_form(rendered = res,
                                 psm = "Please correct your input!",
                                 mode = mode,
                                 ds = ds,
                                 info = info,
                                )
elif psm == '':
    return context.uploads_form(rendered = res,
                                        psm = psm,
                                        ds = ds,
                                        mode = mode,
                                        info = info,
                                       )
elif psm == 'valid':
    pass
filename = ds['upload_file'].filename

if filename not in context.objectIds():
    context.invokeFactory('Upload',filename)
    upload = getattr(context,filename)
    d = {}
    d['filename'] = d['id'] = filename 
    d['upload_date'] =  DateTime.DateTime()
    d['import_layout'] = ds.get('import_layout','')
    d['uploaded_by'] = str(member)
    d['url'] = upload.absolute_url()
    upload.getContent().edit(mapping=d)
    #info['items'].append(d)
request.RESPONSE.redirect(context.absolute_url())    

